package it.amattioli.applicate.browsing;

import it.amattioli.applicate.selection.Selector;
import it.amattioli.dominate.Entity;

import java.io.Serializable;

public interface Browser<I extends Serializable, T extends Entity<I>> extends Selector<I, T> {

	/**
	 * Releases eventually acquired resources. After calling this method the
	 * browser can no longer be used.
	 */
	public void release();
	
	/**
	 * Add a listener for events fired when the browser content changes.
	 * 
	 * @param listener
	 */
	public void addContentChangeListener(ContentChangeListener listener);
	
	/**
	 * Remove a listener for events fired when the browser content changes.
	 * 
	 * @param listener
	 */
	public void removeContentChangeListener(ContentChangeListener listener);
	
}
