package it.amattioli.applicate.commands;

import java.util.EventObject;

public class CommandEvent extends EventObject {
	private CommandResult result;
	private Throwable exc;

	public CommandEvent(Command source, CommandResult result) {
		super(source);
		this.result = result;
	}

	public CommandEvent(Command source, CommandResult result, Throwable exc) {
		this(source, result);
		this.exc = exc;
	}

	public CommandResult getResult() {
		return result;
	}

	public Throwable getExc() {
		return exc;
	}

	@Override
	public String toString() {
		return "CommandEvent[source=" + getSource() + " result=" + result + "]";
	}
	
}
