package it.amattioli.applicate.commands;

import java.beans.PropertyChangeListener;
import java.util.Collections;
import java.util.List;

public class NullListEditor<T> implements ListEditor<T> {
	
	@Override
	public T addRow(Object... param) {
		throw new UnsupportedOperationException();
	}

	@Override
	public T deleteRow() {
		throw new UnsupportedOperationException();
	}

	@Override
	public List<T> getEditingList() {
		return Collections.emptyList();
	}

	@Override
	public BeanEditor<T> getElementEditor(int index) {
		return null;
	}

	@Override
	public int getSelectedIndex() {
		return 0;
	}

	@Override
	public T getSelectedObject() {
		return null;
	}

	@Override
	public boolean isEmptyRow() {
		return false;
	}

	@Override
	public void select(int idx) {
		throw new UnsupportedOperationException();
	}

	@Override
	public void setEditingList(List<T> editingList) {
		throw new UnsupportedOperationException();
	}

	@Override
	public void setEmptyRow(boolean emptyRow) {
		throw new UnsupportedOperationException();
	}

	@Override
	public void addPropertyChangeListener(PropertyChangeListener listener) {
		// Does nothing because the content never changes
	}

	@Override
	public void removePropertyChangeListener(PropertyChangeListener listener) {
		// Does nothing because the content never changes
	}

}
